/* c_sock.c - client for tcp-socket */
#include "inet.h"
#ifdef SUN
#include "../pthread_sol2.7.h"
#endif
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

pthread_t       threadread, threadwrite;

/* read from 0, write to socket */

void *talkread(sockfd)
int *sockfd;
{
   int n;
   char spid[128]; int lspid;
   char sendline[MAXLINE];
   sprintf(spid,"%d - ",getpid());
   lspid = strlen(spid);
   while (write(1,spid,lspid),write(1,"c: ",3),(n=read(0,sendline,
                                MAXLINE)) > 0) {
      if (write(*sockfd,sendline,n) != n) break;
   }
   pthread_cancel(threadwrite);
}

/* read from socket, write to 1 */
void *talkwrite(sockfd)
int *sockfd;
{
   int n; 
   char spid[128]; int lspid;
   char sendline[MAXLINE];
   sprintf(spid,"%d - ",getpid());
   lspid = strlen(spid);
   
   while (1) {
      if ((n=read(*sockfd,sendline,MAXLINE)) 
                                  <= 0) break;
      write(1,"\n",1);
      write(1,sendline,n);
      write(1,spid,lspid);
      write(1,"C: ",3);
   }
   pthread_cancel(threadread);
}

main(argc,argv)
int argc;
char *argv[];
{
   int sockfd;
   struct sockaddr_in serv_addr;
   struct hostent *hp;
   pthread_t       thread1, thread2;
 
   if (argc != 2) {
	  printf("use: %s <hostname>\n", argv[0]);
	  exit(1);
   }
   hp=gethostbyname(argv[1]);
   if ( hp == NULL ) {
         (void) printf("no host '%s'\n",argv[1]);
         exit (3);
   }
   bzero((char *)&serv_addr,sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_port = htons(SERV_TCP_PORT2);
   (void) memcpy(&serv_addr.sin_addr.s_addr, *hp->h_addr_list,
                      sizeof (serv_addr.sin_addr.s_addr));
   if((sockfd=socket(AF_INET,SOCK_STREAM,0))<0){
      fprintf(stderr,
           "c_sock: can't open stream socket\n");
      exit(-1);
   }
   if (connect(sockfd,
               (struct sockaddr *) &serv_addr,
                        sizeof(serv_addr)) < 0) {
      fprintf(stderr,
            "c_sock: can't connect to server\n");
      exit(-2);
   }
  pthread_create(&threadread, 
                 NULL,
                 (void *) talkread,
                 (void *) &sockfd); 
  pthread_create(&threadwrite, 
                 NULL,
                 (void *) talkwrite,
                 (void *) &sockfd); 

   pthread_join(threadread, NULL);
   write(1,"main read\n",10);
   pthread_join(threadwrite, NULL);
   write(1,"\nconnection down\n",17);
   exit(0);
}
